// Generated by Haxe 3.4.0
(function () { "use strict";
var Main = function() { };
Main.main = function() {
	Main.questions = [window.document.getElementById("question_page_0"),window.document.getElementById("question_page_1"),window.document.getElementById("question_page_2")];
	Main.mobileTexts = [window.document.getElementById("mobileTextA"),window.document.getElementById("mobileTextB"),window.document.getElementById("mobileTextC")];
	var _g = 0;
	var _g1 = Main.questions;
	while(_g < _g1.length) {
		var question = _g1[_g];
		++_g;
		question.style.display = "none";
	}
	Main.questions[0].style.display = "block";
	Main.wheelContainer = window.document.getElementById("wheelContainer");
	Main.wheelhintArrow = window.document.getElementById("wheelArrowHint");
	Main.wheelhintArrow.style.position = "absolute";
	Main.wheelhintArrow.style.left = "50%";
	Main.wheelhintArrow.style.transform = "translate(-50%, -100%)";
	Main.oddsTxt = window.document.getElementById("odds");
	Main.wheel_divs = [window.document.getElementById("largeWheel"),window.document.getElementById("medWheel"),window.document.getElementById("smallWheel")];
	var wheelA = new Wheel();
	var wheelB = new Wheel();
	var wheelC = new Wheel();
	Main.wheels = [wheelA,wheelB,wheelC];
	wheelA.wheelIndex = 0;
	wheelB.wheelIndex = 1;
	wheelC.wheelIndex = 2;
	window.onload = function() {
		Main.init();
	};
	window.addEventListener("resize",Main.resized);
};
Main.init = function() {
	Main.wheelContainer.style.display = "block";
	Main.updateLayout();
	var _g1 = 0;
	var _g = Main.wheels.length;
	while(_g1 < _g) {
		var i = _g1++;
		var whl = Main.wheels[i];
		whl.element = Main.wheel_divs[i];
		whl.question = Main.questions[i];
		var snapdeg = [0.0];
		if(i == 0) {
			snapdeg[0] = 45;
		}
		if(i == 1) {
			snapdeg[0] = 60;
		}
		if(i == 2) {
			snapdeg[0] = 90;
		}
		whl.draggable = Draggable.create(whl.element,{ type : "rotation", onDragStart : Main.dragStart, onDragStartParams : [whl], onDrag : Main.dragMove, onDragParams : [whl], throwProps : true, snap : (function(snapdeg1) {
			return function(endvalue) {
				return Math.round(endvalue / snapdeg1[0]) * snapdeg1[0];
			};
		})(snapdeg)})[0];
		var letter = Main.wheelLetters[i];
		var _g3 = 0;
		var _g2 = Main.wheelVals[i];
		while(_g3 < _g2) {
			var j = _g3++;
			var inp = window.document.getElementById("inpwheel_" + ("" + letter) + ("_" + j));
			var txt = window.document.getElementById("wtext_" + ("" + letter) + ("_" + j)).innerText;
			whl.addValue(inp);
			whl.wtext[j] = txt;
		}
		window.console.log(whl);
	}
	Main.latestWheel = Main.wheels[0];
};
Main.dragStart = function(whl) {
	console.log(whl);
	window.document.getElementById("wheelHint").style.display = "none";
	var _g = 0;
	var _g1 = Main.wheels;
	while(_g < _g1.length) {
		var other = _g1[_g];
		++_g;
		other.question.style.display = "none";
	}
	if(Main.latestWheel != whl) {
		TweenLite.fromTo(whl.question,1,{ alpha : 0},{ alpha : 1});
		Main.latestWheel = whl;
	}
	whl.question.style.display = "block";
};
Main.dragMove = function(whl) {
	var rot = whl.draggable.rotation;
	var step = 360 / whl.values.length;
	rot -= step / 2;
	rot %= 360;
	if(rot < 0) {
		rot = 360 - Math.abs(rot);
	}
	rot = 360 - rot;
	var val = Math.floor(rot / step);
	if(whl.currentValue != val) {
		whl.currentValue = val;
		console.log(whl.wtext[val]);
		whl.currentOdds = parseFloat(whl.values[val].value);
		if(val == 0) {
			Main.alreadySelected[whl.wheelIndex] = false;
		} else {
			Main.alreadySelected[whl.wheelIndex] = true;
		}
		Main.updateOdds();
		var txt = Main.mobileTexts[whl.wheelIndex];
		txt.innerText = whl.wtext[val];
		TweenLite.fromTo(txt,0.5,{ css : { color : "#ff0000"}},{ css : { color : "#ffffff"}});
	}
	console.log(whl.values[val].id);
};
Main.updateOdds = function() {
	Main.totalOdds = 0;
	var _g = 0;
	var _g1 = Main.wheels;
	while(_g < _g1.length) {
		var whl = _g1[_g];
		++_g;
		var odd = whl.currentOdds;
		if(odd == null) {
			odd = 0;
		}
		Main.totalOdds += odd;
	}
	Main.oddsTxt.innerText = Main.totalOdds + "%";
};
Main.resized = function(e) {
	Main.updateLayout();
};
Main.updateLayout = function() {
	var rct = Main.wheelContainer.getBoundingClientRect();
	Main.wheelContainer.style.marginBottom = rct.width * 0.5 + "px";
	Main.wheel_divs[1].style.marginTop = rct.width * 0.1 + "px";
	Main.wheel_divs[2].style.marginTop = rct.width * 0.2 + "px";
	window.console.log(rct.width);
};
var Wheel = function() {
	this.wheelIndex = 0;
	this.currentOdds = 0;
	this.wtext = [];
	this.values = [];
};
Wheel.prototype = {
	addValue: function(inp) {
		this.values.push(inp);
	}
};
Main.wheelLetters = ["a","b","c"];
Main.wheelVals = [8,6,4];
Main.alreadySelected = [false,false,false];
Main.totalOdds = 0;
Main.main();
})();
